/*
 * ListItem.java
 *
 * Created on 23 Οκτώβριος 2008, 5:13 μμ
 */

package com.wordpress.cyberpython.lia;
import java.awt.*;
import javax.swing.*;
/**
 *
 * @author  cyberpython
 */
public class LiaListCellRenderer extends javax.swing.JPanel implements javax.swing.ListCellRenderer{
    
    private int Index;

    /** Creates new form ListItem */
    public LiaListCellRenderer() {
        initComponents();     
        jLabel1.setOpaque(true);
        jLabel2.setOpaque(true);
        jLabel3.setOpaque(true);
        jSeparator1.setOpaque(true);
        jSeparator2.setOpaque(true);
    }
    
    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
        Index = index;
        setContents((Character)value);   
        
        if (isSelected) {
                jLabel1.setBackground(list.getSelectionBackground());
                jLabel1.setForeground(list.getSelectionForeground());
                /*jLabel2.setBackground(list.getSelectionBackground());
                jLabel2.setForeground(list.getSelectionForeground());
                jLabel3.setBackground(list.getSelectionBackground());
                jLabel3.setForeground(list.getSelectionForeground());
                jSeparator1.setBackground(list.getSelectionBackground());
                jSeparator1.setForeground(list.getSelectionForeground());
                jSeparator2.setBackground(list.getSelectionBackground());
                jSeparator2.setForeground(list.getSelectionForeground());*/
            } else {
                jLabel1.setBackground(list.getBackground());
                jLabel1.setForeground(list.getForeground());
                /*jLabel2.setBackground(list.getBackground());
                jLabel2.setForeground(list.getForeground());
                jLabel3.setBackground(list.getBackground());
                jLabel3.setForeground(list.getForeground());
                jSeparator1.setBackground(list.getBackground());
                jSeparator1.setForeground(list.getForeground());
                jSeparator2.setBackground(list.getBackground());
                jSeparator2.setForeground(list.getForeground());*/
            }
            setEnabled(list.isEnabled());
        
        return this;
    }
    
    public void setContents(Character content){
        jLabel1.setText(String.valueOf(Index));
        if(content == null){
            jLabel2.setText("");
            jLabel3.setText("<undefined>");
        }
        else{
            jLabel2.setText(Utilities.decodeInstruction(content));
            jLabel3.setText(Utilities.to16BitBinaryString(content));
        }
    }
    
    public int getIndex(){
        return Index;
    }
    
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel2 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel3 = new javax.swing.JLabel();

        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(com.wordpress.cyberpython.lia.LiaApp.class).getContext().getResourceMap(LiaListCellRenderer.class);
        jLabel1.setFont(resourceMap.getFont("jLabel1.font")); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        jLabel1.setName("jLabel1"); // NOI18N

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
        jSeparator1.setName("jSeparator1"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jSeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);
        jSeparator2.setName("jSeparator2"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 187, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
            .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 14, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    // End of variables declaration//GEN-END:variables

}
