/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.wordpress.cyberpython.lia;

/**
 *
 * @author cyberpython
 */
public class Utilities {
    
    public static String addLeadingZeroesTo16BitBinaryString(String binaryValue){
        
        int length = binaryValue.length();
        
        while(binaryValue.length() < 16){
            binaryValue = "0"+binaryValue;
        }
        
        return binaryValue;
        
    }
    
    public static String decodeInstruction(Character c){
        if(c == null){
            return "<undefined>";
        }
        char v = c.charValue();
        if(v < 4096){
            return String.valueOf( (int)v );
        }
        else {

            char instruction = (char) (v & Constants.instr_mask);
            char address = (char) (v & Constants.addr_mask);

            switch (instruction) {

                case Constants.INSTR_LOAD:
                    return "LOAD "+String.valueOf((int)address );
                case Constants.INSTR_STORE:
                    return "STORE "+String.valueOf((int)address );
                case Constants.INSTR_ADD:
                    return "ADD "+String.valueOf((int)address );
                case Constants.INSTR_SUBTRACT:
                    return "SUBTRACT "+String.valueOf((int)address );
                case Constants.INSTR_MULTIPLY:
                    return "MULTIPLY "+String.valueOf((int)address );
                case Constants.INSTR_DIVIDE:
                    return "DIVIDE "+String.valueOf((int)address );
                case Constants.INSTR_JUMP:
                    return "JUMP "+String.valueOf((int)address );
                case Constants.INSTR_JUMPZERO:
                    return "JUMPZERO "+String.valueOf((int)address );
                case Constants.INSTR_JUMPMSB:
                    return "JUMPMSB "+String.valueOf((int)address );
                case Constants.INSTR_JUMPSUB:
                    return "JUMPSUB "+String.valueOf((int)address );
                case Constants.INSTR_RETURN:
                    return "RETURN "+String.valueOf((int)address );
                default: {
                    return "<unknown>";
                }
            }

        }
    }   
    
    
    public static String to16BitBinaryString(Character c){
        
        String binaryValue = Integer.toBinaryString( (int)c.charValue() );
        
        int length = binaryValue.length();
        
        while(binaryValue.length() < 16){
            binaryValue = "0"+binaryValue;
        }
        
        return binaryValue;
        
    }

}
